<?php

/*  Copyright 2010  Robert Sebille  (email : robert -AT- sebille -DOT- be)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

// encode les adresses
function rspipcm_encode($adr) {
   $email = ""; $ch = "";

   $curenc = mb_internal_encoding();
   if (mb_detect_encoding($adr) == "UTF-8") {mb_internal_encoding("UTF-8");}

   for ($i = (mb_strlen($adr) - 1); $i > -1; $i--) {
      $ch = mb_substr($adr, $i, 1);
      if ($ch=="@") {$ch=":";}
      if ($ch=="?") {$ch="!";}
      if ($ch=="&") {$ch="#";}
      $email .= $ch;
      }
   
   $email = str_replace("'", " ", $email);
   $email = str_replace('"', '', $email);
  
   mb_internal_encoding($curenc);   
   
 //     $email = "javascript:mdecode('".$email."');";
   
   return $email;
   }

//Filtre les emails
function rspipcm_filtre_email($texte) {
   $val_array = array();   
   $to_replace = array();
   // on matche les raccourcis liens de spip
//   preg_match_all("/\[.*->[a-z]{0,6}(:)?(\/){0,2}[a-z0-9@\.\?=&áàâäãåçéèêëíìîïñóòôöõúùûüýÿ( )]*\]/iU", $texte, $to_replace);
   preg_match_all("/\[.*->.*[a-z0-9@\.\?=&áàâäãåçéèêëíìîïñóòôöõúùûüýÿ( )]*\]/iU", $texte, $to_replace);
   foreach ($to_replace[0] as $val) {
      $val = str_replace(array("[","]"), "", $val);
      // Parmi les raccourcis lien de spip, on matche les raccourcis mailto
      if (preg_match("/mailto:/", $val)) {
         $val_array = explode("->mailto:", $val);
         // Si la partie du raccourci spip avant -> est vide, on lui affecte la partie après
         if ($val_array[0] != "") {$val_nom = $val_array[0];} else {$val_nom = $val_array[1];}
         // on extrait le domaine l'adresse email
         $val_domaine = substr(strstr($val_array[1], "@"), 1);
         // Si il y a des parametres on les supprime
         if (preg_match("/\?/", $val_array[1])) {
            $val_domaine = substr($val_domaine, 0, strpos($val_domaine, "?"));
            } // if (preg_match("/\?/", $val_nom)) {
         // On extrait le user (qui servira pour le noscript
         $val_user = substr($val_array[1], 0, strpos($val_array[1], "@"));
         // Si le nom du lien contient l'adresse email, on la traite
         if (preg_match("/@/", $val_nom)) {
            $val_nom_user = ucfirst(substr($val_nom, 0, strpos($val_nom, "@")));
            // Si il y a des . dans user on l'eclate: par exple: nom.prenom > Nom Prenom
            if (preg_match("/\./", $val_nom_user)) {
               $val_nom_user_array = explode(".", $val_nom_user); $user_prov = "";
               foreach ($val_nom_user_array as $val_u) {$user_prov .= ucfirst($val_u)." ";}
               $val_nom_user = rtrim($user_prov);
               } // if (preg_match("/\?/", $val_nom_user))
            $val_nom = _T('rspipcm:ecrire_a_pre').$val_nom_user._T('rspipcm:ecrire_a_post')." "._T('rspipcm:dans_le_nom_de_domaine').": ".$val_domaine;
            } // if (preg_match("/@/", $val_nom))
         
         $val_code = rspipcm_encode($val_array[1]);
 
         $to_replace = "<a href=\"javascript:mdecode('".$val_code."');\">".$val_nom."</a>";
         // Accessibilite: si javascript est desactive.
         // RSPIPCM_... sont traites post_typo pour eviter que spip mette des <p></p> inopportuns ici. Pas de \n ici, spip n'aime pas ;).
         $to_replace .= "RSPIPCM_NOSCRIPTDIV_START"._T('rspipcm:javascript_est_desactive')."<br />"._T('rspipcm:veuillez_reconstituer_l_adresse_email')."<br />"._T('rspipcm:utilisateur')." : ". $val_user."<br />"._T('rspipcm:domaine')." : ". $val_domaine."RSPIPCM_NOSCRIPTDIV_END";
         $texte = str_replace("[".$val."]", $to_replace, $texte);
            
         } // if (preg_match("mailto:", $val)

      } // foreach ($to_replace[0] as $val)

   return $texte;
}

// Remplace RSPIPCM_.. post_typo pour eviter que spip mette des <p></p> inopportuns
function rspipcm_supprime_par_noscript($texte) {
        $texte = str_replace("RSPIPCM_NOSCRIPTDIV_START", "<noscript><div class=\"rspipcm_noscript\">", $texte);
        $texte = str_replace("RSPIPCM_NOSCRIPTDIV_END", "</div></noscript>", $texte);
	return $texte;
}

?>
